"{ Package: 'stx:goodies/monticello' }"

"{ NameSpace: Smalltalk }"

MCDefinition subclass:#MCClassComment
	instanceVariableNames:'className comment source'
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Monticello-Modeling'
!


!MCClassComment methodsFor:'accessing'!

actualClass
        ^Smalltalk classNamed: self className
!

className
    ^ className
!

className:classNameArg comment:commentArg source:sourceArg 
    className := classNameArg.
    comment := commentArg.
    source := sourceArg.
!

comment
    ^ comment
!

sortKey
    ^ self summary

    "Modified: / 25-05-2020 / 12:42:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

source
    ^ source
! !

!MCClassComment methodsFor:'comparing'!

description
    "superclass MCDefinition says that I am responsible to implement this method"

    ^ Array with: self summary

    "Modified: / 25-05-2020 / 12:34:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MCClassComment methodsFor:'converting'!

asChange
    ^ ClassCommentChange new className:self className comment:self comment
! !

!MCClassComment methodsFor:'loading'!

load
    |actualClass|

    actualClass := self actualClass.
    actualClass comment:comment
! !

!MCClassComment methodsFor:'printing'!

summary
    "superclass MCDefinition says that I am responsible to implement this method"

    ^ className , ' (comment)'

    "Modified: / 25-05-2020 / 12:34:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MCClassComment methodsFor:'visiting'!

accept:aVisitor
    "raise an error: must be redefined in concrete subclass(es)"

    ^ aVisitor visitClassComment: self.

    "Created: / 25-05-2020 / 12:38:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MCClassComment class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCClassComment.st,v 1.2 2014-12-23 19:47:11 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCClassComment.st,v 1.2 2014-12-23 19:47:11 cg Exp $'
! !

